# $Id$

package ObsData::Archive::FlatFile;

use strict;
use warnings;
use File::Copy;
use File::Temp qw/ tempfile /;
use ObsData::Archive;

our @ISA = qw(ObsData::Archive);

sub new {
    my ($class, $options) = @_;
    bless($options, $class);
}

sub DESTROY {
    my ($self) = @_;
}

sub ls {
    my ($self) = @_;
    my ($file) = $self->{archive} =~ m!^(?:.*/)?(.*)!;
    return $file;
}

sub extract {
    my ($self, $file, $dest) = @_;
    # the devel should specify the file he want
    # as the basic contains only 1 file... this does not matter

    my ($fh, $fname);
    
    if ($dest) {
        $fname = $dest;
        if(!open($fh, '>', $dest)) {
            $self->seterror($!);
            return undef;
        }
    } else {
        ($fh, $fname) = tempfile(
            DIR => $self->_tempdir,
            UNLINK => 1,
        ) or do {
            $self->seterror("Can't create tempfile: $!");
            return undef;
        };
    }
    
    if(!copy($self->{archive}, $fh)) {
        unlink($fname);
        $self->seterror("Cant copy the archive: $!");
        return undef;
    }
    
    close($fh);
    $fname
}

ObsData::Archive::register('.*', 'FlatFile', 10);
